<?php
    if (isset($_POST['submit'])) {

        $topicID = intval($_POST['topicID']);
        $title = htmlspecialchars($_POST['videoTitle'], ENT_QUOTES);
        $url = htmlspecialchars($_POST['videoLink'], ENT_QUOTES);
        $category = htmlspecialchars($_POST['category'], ENT_QUOTES);
        $creator = htmlspecialchars($_POST['creator'], ENT_QUOTES);
        $description = htmlspecialchars($_POST['description'], ENT_QUOTES);
        $flowchart = htmlspecialchars($_FILES["flowchart"]["name"], ENT_QUOTES);
        
        $url = strpos($url, "youtu.be/") ? str_replace("youtu.be/", "youtube.com/embed/", $url) : $url;       

        require_once ("../connection_manager.php");
        $conn = new connection_manager();
        $dbConn = $conn->connection;

        // check if the flowchart is exist to update the database
        if ($flowchart != "") {
            $timestampPicture = time();
            $flowchart = "images/trainingmodules/". $category . "-" . $timestampPicture . "-" . basename($_FILES["flowchart"]["name"]);
            $imageFileType  = strtolower(pathinfo($flowchart,PATHINFO_EXTENSION)); 

            if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg") {
                $error_msg = "Sorry, only JPG, JPEG & PNG files are allowed.";
                header("location:../operation-manual.php?topic=".$topicID."&status=WrongFileType");
                exit(); //stop
            }

            // Get the temporary file name
            $tempname = $_FILES["flowchart"]["tmp_name"];    

            $file_path = "../images/trainingmodules/";
            if (!is_dir($file_path)) {
                mkdir($file_path, 0777, true);
            }            

            // Now let's move the uploaded image into the folder: image
            move_uploaded_file($tempname, "../". $flowchart);

            $sqlEditVideo = "UPDATE training_module SET category = '" . $category . "',
                             title = '" . $title . "', 
                             video_url = '" . $url . "', 
                             creator = '" . $creator . "', 
                             `description` = '" . $description . "', 
                             flowchart = '" . $flowchart . "' 
                             WHERE id = " . (int)$topicID;
            
            $result = mysql_query($sqlEditVideo);

            if (!$result) {
                header("location:../operation-manual.php?topic=".$topicID."&status=updateFailed");
                exit(); //stop
            }

        } else {

            $sqlEditVideo = "UPDATE training_module SET category = '" . $category . "',
            title = '" . $title . "', 
            video_url = '" . $url . "', 
            creator = '" . $creator . "', 
            description = '" . $description . "'
            WHERE id = " . (int)$topicID;

            $result = mysql_query($sqlEditVideo);

            if (!$result) {
                header("location:../operation-manual.php?topic=".$topicID."&status=updateFailed");
                exit(); //stop
            }     
            
        }

        // Delete previously inserted timeline
        $sqlDeleteTimeline = "DELETE FROM training_module_timeline WHERE module_id = " . (int)$topicID;
        $resultDeleteTimeline = mysql_query($sqlDeleteTimeline);

        if (!$resultDeleteTimeline) {
            header("location:../operation-manual.php?topic=".$topicID."&status=deleteFailedinTimeline");
            exit(); //stop
        }

        // Insert new timeline
        $timestamps = $_POST['timestamps'];
        $descriptions = $_POST['descriptions'];

        for ($i = 0; $i < count($timestamps); $i++) {
            $timestamp = mysql_real_escape_string(htmlspecialchars($timestamps[$i], ENT_QUOTES));
            $description = mysql_real_escape_string(htmlspecialchars($descriptions[$i], ENT_QUOTES));

            // Insert into training_module_timeline table
            $sqlTimeline = "INSERT INTO training_module_timeline (module_id, timestamp, description) VALUES (" . (int)$topicID . ", '" . $timestamp . "', '" . $description . "')";
            $resultTimeline = mysql_query($sqlTimeline);

            if (!$resultTimeline) {
                header("location:../operation-manual.php?topic=".$topicID."&status=insertFailedinEdit");
                exit(); //stop
            }
        }

        header("location:../operation-manual.php?topic=".$topicID."&status=updateSuccess");
        exit(); //stop
    }
?>