<?
session_start(); // Start the session

// This variable is set to zero for the first page
if(!isset($_SESSION["username"])) {
header("Location: index.php");
}

extract($_POST);
extract($_GET);

// Connect Database
require "connection_manager.php";
require_once('classes/tc_calendar.php');
$conn = new connection_manager();
$dbConn = $conn->connection;

$dept = "";
$today = date("Y-m-d");

// When submit is clicked
if(isset($_GET['dept'])){
	$dept = $_GET['dept'];
}

// FUNCTIONS -----------------------------------------------------------------------
// Get latest 14 days total views
function get_14days_views($today, $dept){
	$sql = "SELECT COUNT(*) FROM traffic_tracking WHERE page='ksk_planning_insight' AND dept='" . $dept .
	       "' AND DATEDIFF('$today', dateandtime) <= 14" .
				 " AND loginuser NOT IN ('liwin', 'hocknew', 'demoacc', 'chchuah')";
	$result = mysql_query($sql);
 	echo mysql_error();

	$total_views = mysql_fetch_assoc($result)['COUNT(*)'];
	return $total_views;
}

// Generate dataset for number of views in last 14 days
function get_14days_views_dataset($today, $dept){
	$sql = "SELECT DATE(dateandtime) AS date, COUNT(*) AS views FROM traffic_tracking" .
				 " WHERE page='ksk_planning_insight' AND dept='" . $dept .
				 "' AND DATEDIFF('$today', dateandtime) <= 14" .
				 " AND loginuser NOT IN ('liwin', 'hocknew', 'demoacc', 'chchuah')" .
				 " GROUP BY date";
	$result = mysql_query($sql);
  echo mysql_error();

	$data = array();
	while($row = mysql_fetch_assoc($result)){
		$data[] = $row;
	}

	return $data;
}

// Get average engagemet in last 14 days
function get_14days_engagement($today, $dept){
	$sql = "SELECT TIME_FORMAT(SEC_TO_TIME(AVG(TIME_TO_SEC(duration))), '%im %ss') as avg_duration" .
	  		 " FROM traffic_tracking WHERE page='ksk_planning_insight' AND dept='" . $dept .
				 "' AND DATEDIFF('$today', dateandtime) <= 14" .
				 " AND loginuser NOT IN ('liwin', 'hocknew', 'demoacc', 'chchuah')";
  $result = mysql_query($sql);
	echo mysql_error();

	$avg_duration = mysql_fetch_assoc($result)['avg_duration'];
	if ($avg_duration == ''){
		$avg_duration = '-';
	}

	return $avg_duration;
}

// Get highest frequency day in last 14 days
function get_14days_highest_day($today, $dept){
  $sql = "SELECT DAYNAME(dateandtime) AS DAY, COUNT(*) AS frequency FROM traffic_tracking" .
         " WHERE page='ksk_planning_insight' AND dept='" . $dept .
         "' AND DATEDIFF('$today', dateandtime) <= 14" .
         " AND loginuser NOT IN ('liwin', 'hocknew', 'demoacc', 'chchuah')" .
         " GROUP BY DAY ORDER BY frequency DESC";
  $result = mysql_query($sql);
  echo mysql_error();

  $highest = array();
  while ($row = mysql_fetch_assoc($result)) {
    $day = $row['DAY'];
    $frequency = $row['frequency'];
    if (empty($highest) || $frequency == $highest[0]['frequency']) {
      $highest[] = $row;
    } else {
      break;
    }
  }

  if (count($highest) == 1) {
    return $highest[0]['DAY'];
  } else {
    $days = array();
    foreach ($highest as $row) {
      $days[] = $row['DAY'];
    }
    return implode(", ", $days);
  }
}

// Get overall views dataset
function get_overall_views_dataset($dept){
	$sql = "SELECT t.loginuser, u.name, u.accesslevel, COUNT(*), TIME_FORMAT(SEC_TO_TIME(AVG(TIME_TO_SEC(duration))), '%im %ss') as avg_duration" .
	 			 " FROM traffic_tracking AS t" .
	 			 " JOIN systemuser AS u ON t.loginuser = u.username" .
				 " WHERE t.page='ksk_planning_insight' AND t.dept='" . $dept .
				 "' AND t.loginuser NOT IN ('liwin', 'hocknew', 'demoacc', 'chchuah')" .
				 " GROUP BY t.loginuser";
  $result = mysql_query($sql);
  echo mysql_error();

	$data = array();
	while($row = mysql_fetch_assoc($result)){
		$data[] = $row;
	}

	return $data;
}

// Get raw data of the department
function get_raw_data($dept){
	$sql = "SELECT * FROM traffic_tracking" .
				 " WHERE PAGE='ksk_planning_insight' AND dept='" . $dept .
				 "' AND loginuser NOT IN ('liwin', 'hocknew', 'demoacc', 'chchuah')" .
				 " ORDER BY dateandtime DESC";
	$result = mysql_query($sql);
	echo mysql_error();

	$data = array();
	while($row = mysql_fetch_assoc($result)){
		$data[] = $row;
	}
	return $data;
}
?>

<!-- Start of html page ----------------------------------------------------------->
<?include("header.php");?>

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">

<style>
.custom-table-container{
	max-height:500px;
	overflow:auto;
}

.custom-table {
  font-family: Arial, Helvetica, sans-serif;
  border-collapse: collapse;
	width: 100%;
}

.custom-table td, .custom-table th {
  border: 1px solid #ddd;
  padding: 8px;
}

.custom-table tr:nth-child(even){background-color: #f2f2f2;}

.custom-table tr:hover {background-color: #ddd;}

.custom-table th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #FF8000;
  color: white;
	position: sticky;
	top:0;
}

.search-input {
  padding: 8px;
  border: 1px solid #ccc;
  border-radius: 5px;
  background-color: #f2f2f2;
  font-size: 14px;
  width: 200px;
}

.search-input:focus {
  outline: none;
  border: 1px solid #FF8000;
  background-color: #fff;
}

.dept-select-container {
	 position: relative;
	 display: inline-block;
	 margin-top: 10px;
 }

#main-content {
		 position: relative;
 }

 #all-dept-select-button {
 	 font-size: 170%;
 	 display: none; /* Set display to none by default */
 	 position: absolute;
 	 top: 50%;
 	 transform: translateY(-50%);
 	 background-color: white;
 	 color: #FF8000;
 	 border:none;
 	 padding: 10px 10px;
 	 border-radius: 20px;
 	 transition: all 0.3s ease-in-out;
 }

 #all-dept-select-button:hover {
 	 background-color:#FF8000;
 	 color: white;
 }

 #main-content.multi-row:hover #all-dept-select-button {
 	 display: block; /* Display the button only when hovering over main-content and there are more than 1 rows */
 }

#dept-select-button {
	 font-size: 170%;
	 display: none; /* Set display to none by default */
	 position: absolute;
	 top: 50%;
	 transform: translateY(-50%);
	 background-color: white;
	 color: #FF8000;
	 border:none;
	 padding: 10px 10px;
	 /* margin-left: 90px; */
	 border-radius: 20px;
	 transition: all 0.3s ease-in-out;
}

#dept-select-button:hover {
	 background-color:#FF8000;
	 color: white;
}

#main-content.multi-row:hover #dept-select-button {
	 display: block; /* Display the button only when hovering over main-content and there are more than 1 rows */
}

#main-content p {
	 font-size: 220%;
	 border-left: 5px solid #FF8000;
	 padding-left: 8px;
	 margin-left: 0;
	 transition: all 0.3s ease-in-out;
}

#main-content.multi-row:hover p {
	 /* margin-left: 210px; */
	 margin-left: 130px;
}

.custom_modal {
  display: none;
  position: fixed;
  z-index: 999;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  overflow: auto;
  background-color: rgba(0, 0, 0, 0.4);
}

.custom_modal-content {
  background-color: #fff;
  margin: 10% auto;
  padding: 20px;
  border: 1px solid #ccc;
  border-radius: 5px;
  max-width: 500px;
}

.custom_modal-content ul {
  list-style: none;
  margin: 0;
  padding: 0;
}

.custom_modal-content li {
  padding: 10px;
  cursor: pointer;
  border: 1px solid #ccc;
  border-radius: 5px;
  margin-bottom: 10px;
  transition: background-color 0.3s ease-in-out;
}

.custom_modal-content li:hover {
  background-color: #FFA500;
  color: white;
}

.custom_modal-content li[data-dept]:before {
  content: "";
  display: inline-block;
  width: 10px;
  height: 10px;
  border-radius: 50%;
  margin-right: 5px;
  background-color: #FFA500;
}

.close {
  float: right;
  font-size: 28px;
  font-weight: bold;
  cursor: pointer;
  transition: color 0.3s ease-in-out;
}

.close:hover {
  color: #FFA500;
}

.custom-container {
  padding: 20px;
  background-color: #fff;
  box-shadow: 0 0 5px rgba(0, 0, 0, 0.1);
	margin: 0 10px 20px 10px;
}

.custom-container-content {
  display: flex;
  justify-content: space-between;
  flex-wrap: wrap;
}

.custom-container-item {
  width: calc(33.33%);
  margin-bottom: 10px;
}

.custom-container-item h3 {
  margin: 0;
  font-size: 1.4rem;
  font-weight: bold;
}

.custom-container-item p {
  margin: 0;
  font-size: 1.1rem;
}
</style>

<!-- Content -->
<div id="content">
	<div id="main">
		<!-- Header ------------------------------------------------------------------->
		<div id="main-title">KSK Planning Insight - Traffic Tracking</div>

		<?
		// Obtain all (or relevant) site list
		if($_SESSION["acesslevel"]=="SSA" || $_SESSION["acesslevel"]=="SA" || $_SESSION["acesslevel"]=="AC" ){
			$sql_dept = "select * from dept order by code";
		}else{
			$sql_dept = "select * from sitelist where incharge='" . $_SESSION['username'] . "' order by name";
		}
		$result_dept = mysql_query($sql_dept);
		echo mysql_error();
		?>

		<div id="main-content" class='multi-row'>
		<button id="dept-select-button">Switch Projects</button>
		<!-- TODO -->
		<!-- <button id="all-dept-elect-button" onclick="window.location.href='https://metrio.qubit-software.com.my/ksk-planning-insight-traffic.php?dept=AllProjects'">All Projects</button> -->

		<!-- Dept and date Info -->
		<p style="font-size:220%;">
			<b><?php echo $dept;?></b>
			<br>Date: <?php echo date("Y-m-d");?>
		</p>

		<!-- Site list Info -->
	  <div class="dept-select-container">
	    <div id="dept-select-modal" class="custom_modal" style="font-size:170%;">
	      <div class="custom_modal-content">
	        <span class="close">&times;</span>
	        <ul>
						<?while($row = mysql_fetch_assoc($result_dept)){
								if($_SESSION["acesslevel"]=="SSA" || $_SESSION["acesslevel"]=="SA" || $_SESSION["acesslevel"]=="AC" ){?>
									<li data-dept="<?echo $row['code'];?>"><?echo $row['code'];?></li>
							<?}
								else{?>
									<li data-dept="<?echo $row['name'];?>"><?echo $row['name'];?></li>
							<?}
							}?>
	        </ul>
	      </div>
	    </div>
	  </div>
	</div> <!-- main content -->

	<!------------------------------------------------------------------------------------>
<div class="parent-container" style="display: flex;">
	<!-- Data in last 14 days ------------------------------------------------------------>
  <div class="custom-container" style="width: 60%;">
    <div class="custom-container-content">
      <div class="custom-container-item">
				<p>Views <span style="font-size:60%"><i>in last 14 days</i></span<</p>
				<h3><?echo get_14days_views($today, $dept);?></h3>
      </div>
      <div class="custom-container-item">
				<p>Average Engagement Time</p>
        <h3><?echo get_14days_engagement($today, $dept);?></h3>
      </div>
      <div class="custom-container-item">
				<p>Highest Traffic</p>
        <h3><?echo get_14days_highest_day($today, $dept);?></h3>
      </div>
  	</div>

		<!-- Line graph -->
		<div class="custom-container-content">
			<div id="recent_view_chart" style="width:100%; height: 500px"></div>
		</div>
	</div>

	<!-- Overall Data ------------------------------------------------------------------>
	<div class="custom-container" style="width:40%;">
		<div class="custom-container-content">
			<div class="custom-container-item">
				<p>OVERALL VIEWS</p>
				<?$overall_data = get_overall_views_dataset($dept);
					$total_count = 0;
					foreach ($overall_data as $user_data){
						$user_views = $user_data['COUNT(*)'];
						$total_count+= $user_views;
					}
				?>
				<h3><?echo $total_count;?></h3>
			</div>
		</div>

		<!-- Graph-->
		<div class="custom-container-content">
			<div id="user_view_chart" style="width:100%; height: 250px"></div>
		</div>

		<!-- Top Contributor -->
		<div class="custom-container-content">
			<div class="custom-container-item" style="width:100%;">
				<p style="margin:10px 0 10px 0;">Top Contributor</p>
				<div class="custom-table-container" style="height:200px;">
				  <table class="custom-table">
				    <thead>
				      <tr>
				        <th>Users</th>
				        <th>Views</th>
								<th>Avg Duration</th>
				      </tr>
				    </thead>
				    <tbody>
						<?foreach ($overall_data as $user_data){?>
				      <tr>
				        <td><?echo $user_data['loginuser'];?></td>
								<td><?echo $user_data['COUNT(*)'];?></td>
								<td><?echo $user_data['avg_duration'];?></td>
				      </tr>
						<?}?>
				    </tbody>
				  </table>
				</div>
			</div>
		</div>

  </div>
</div> <!-- parent container -->

<div class="custom-container">
	<div class="custom-container-content">
		<div class="custom-container-item" style="width:100%;">
			<p style="margin:10px 0 10px 0;">FULL DETAILS</p>
			<div class="custom-table-container">
				<table class="custom-table">
					<thead>
						<tr>
							<th>Login User</th>
							<th>Page</th>
							<th>Dept</th>
							<th>Date and Time</th>
							<th>Duration</th>
						</tr>
					</thead>
					<tbody>
						<?
							$raw_data = get_raw_data($dept);
							foreach ($raw_data as $data){?>
				      <tr>
				        <td><?echo $data['loginuser'];?></td>
								<td><?echo $data['page'];?></td>
								<td><?echo $data['dept'];?></td>
								<td><?echo $data['dateandtime'];?></td>
								<td><?echo $data['duration'];?></td>
				      </tr>
						<?}?>
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>

<!------------------------------------------------------------------------------------->

  </div> <!-- main -->
</div> <!-- content -->

<!-- site selection pop up -->
<script>
var deptSelectButton = document.getElementById('dept-select-button');
var deptSelectModal = document.getElementById('dept-select-modal');
var deptSelectModalContent = deptSelectModal.querySelector('.custom_modal-content');
var deptSelectModalClose = deptSelectModal.querySelector('.close');
var deptSelectModalOptions = deptSelectModal.querySelectorAll('li');

deptSelectButton.addEventListener('click', function() {
  deptSelectModal.style.display = 'block';
});

deptSelectModalClose.addEventListener('click', function() {
  deptSelectModal.style.display = 'none';
});

deptSelectModalOptions.forEach(function(deptOption) {
  var deptOptionValue = deptOption.getAttribute('data-dept');
  deptOption.addEventListener('click', function() {
    var newDept = deptOptionValue;
    var currentUrl = window.location.href;
    var newUrl = currentUrl.replace(/dept=([^&]+)/, 'dept=' + newDept);
window.location.href = newUrl;
});
});

window.addEventListener('click', function(event) {
if (event.target == deptSelectModal) {
deptSelectModal.style.display = 'none';
}
});
</script>

<!-- Chart and Graph -->
<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<script type="text/javascript">
google.charts.load('current', {'packages':['corechart']});
google.charts.setOnLoadCallback(()=>{
	drawRecentViewChart();
	drawUserViewChart();
});

function drawRecentViewChart() {
  var data = new google.visualization.DataTable();
  data.addColumn('string', 'Date');
  data.addColumn('number', 'Views');
  data.addColumn({type: 'string', role: 'annotation'});

  <?php
  $all_views = get_14days_views_dataset($today, $dept);
  foreach ($all_views as $view){
    $date = new DateTime($view['date']);
    $dateString = $date->format('d-M');
    $views = $view['views'];
    $label = $date->format('D');
    echo "data.addRow(['$dateString', $views, '$label']);";
  }
  ?>

  var options = {
    title: 'Views in last 14 days',
    curveType: 'function',
    legend: { position: 'bottom' },
    pointSize: 5,
    pointShape: 'circle',
    annotations: {
      textStyle: {
        fontSize: 12,
        color: 'black'
      }
    },
    pointLabel: {
      fontName: 'Arial',
      fontSize: 12,
      color: '#333333'
    }
  };

  var chart = new google.visualization.LineChart(document.getElementById('recent_view_chart'));
  chart.draw(data, options);
}


function drawUserViewChart() {
	var data = new google.visualization.DataTable();
  data.addColumn('string', 'User');
  data.addColumn('number', 'Views');
	data.addColumn({type: 'string', role: 'annotation'});
	data.addColumn('number', 'Duration(min)');

  <?php
  $overall_views = get_overall_views_dataset($dept);
  foreach ($overall_views as $user_data){
    $users = $user_data['loginuser'];
    $views = $user_data['COUNT(*)'];
		$label = $user_data['accesslevel'];

		$avg_duration = $user_data['avg_duration'];
		// convert avg duration to minutes
		$duration_parts = explode(' ', $avg_duration);
		$duration_minutes = (int)$duration_parts[0]; // extract minutes
		$duration_seconds = (int)$duration_parts[1]; // extract seconds
		$avg_duration_minutes = $duration_minutes + ($duration_seconds / 60);

    echo "data.addRow(['$users', $views, '$label', $avg_duration_minutes]);";
  }
  ?>

  var options = {
    title: 'Overall Performance',
    vAxis: {minValue: 0},
    legend: { position: 'bottom' }
  };

  var chart = new google.visualization.ColumnChart(document.getElementById('user_view_chart'));
  chart.draw(data, options);
}
</script>

</body>
</html>
