<?php 
session_start();
extract($_GET);
require "connection_manager.php";
$conn = new connection_manager();
$dbConnection = $conn->connection; 
?>
<html>
<body>
<table style="margin-bottom:10px;" class='table2'  width="100%" border="0" align="center" cellspacing="1" bgcolor="WHITE">
<tr valign="middle" class="tablerowdata" ><td height="21"  font color="#333333" colspan="4" align="center"><font size="5"><b>General Worker Expenses Report : <?=$dept?></b></font></td></tr>
<tr valign="middle" class="tablerowdata" ><td height="10"  font color="#333333" colspan="4" align="center"></td></tr>
</table>
<?//css tr background colour based on array size
$arr=array();
$sql="select otcriteria,incharge,
sum(round(totalpay,2)) as expense,
sum(round(if(backcharge!=''||bc_hour>0,totalpay/(adjworkinghour+adjot)*bc_hour,0),2)) as bc,
sum(if(preot>0,1,0)) as preot_app,
DATE_FORMAT(CONCAT(substr(cdate,1,7),'-01'),'%b %y') as yearmonth,
substr(cdate,6,2) as month,
left(cdate,4) as year,
sum(if(cin=cout or cout='0000-00-00',1,0)) as dco,
sum(1) as ci 
from rosterdetail where cdate>=date_sub(date_format('$year-$month-01','%Y-%m-01'), interval 11 month) and 
cdate<=LAST_DAY('$year-$month-01') and 
dept='$dept' 
group by yearmonth,incharge,otcriteria 
order by year asc,month asc,incharge asc,otcriteria asc";
$res=mysql_query($sql);
while($row=mysql_fetch_array($res)){
    array_push($arr,$row);
}
$month_array=array();
$incharge_array=array();
$otcriteria_array=array();
$chart_array=array(["month","dco/ci"]);
$maxdco=0;$mindco=0;
$maxci=0;$minci=0;
foreach(array_unique(array_column($arr, 'incharge')) as $incharge){
    $incharge_row=array($incharge,0);
    array_push($incharge_array,$incharge_row);
}
foreach(array_unique(array_column($arr, 'otcriteria')) as $otcriteria){
    $otcriteria_row=array($otcriteria,0,0,0);
    array_push($otcriteria_array,$otcriteria_row);
}
foreach(array_unique(array_column($arr, 'yearmonth')) as $month){
    $month_row=array($month,0,0,$incharge_array,$otcriteria_array,0,0);
    array_push($month_array,$month_row);
}
for($i=0;$i<sizeof($month_array);$i++){
    foreach($arr as $main_array){
        if($main_array[yearmonth]==$month_array[$i][0]){
            $month_array[$i][1]+=$main_array[dco];
            $month_array[$i][2]+=$main_array[ci];
        }
        for($j=0;$j<sizeof($incharge_array);$j++){
            if($main_array[incharge]==$incharge_array[$j][0]&&$main_array[yearmonth]==$month_array[$i][0]){
                $month_array[$i][3][$j][1]+=$main_array[preot_app];
            }
        }
        for($j=0;$j<sizeof($otcriteria_array);$j++){
            if($main_array[otcriteria]==$otcriteria_array[$j][0]&&$main_array[yearmonth]==$month_array[$i][0]){
                $month_array[$i][4][$j][1]+=$main_array[expense];
                $month_array[$i][4][$j][2]+=$main_array[bc];
                $otcriteria_array[$j][3]+=$main_array[expense];
            }
        }
    }
    if(($month_array[$i][1]/$month_array[$i][2])>$maxdco)$maxdco=($month_array[$i][1]/$month_array[$i][2]);
    if(($month_array[$i][1]/$month_array[$i][2])<$mindco||$mindco==0)$mindco=($month_array[$i][1]/$month_array[$i][2]);
    array_push($chart_array,[$month_array[$i][0],round($month_array[$i][1]/$month_array[$i][2],2)]);
}
?>

<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<body>
<div id="myChart" style="width:100%; height:500px;" onload="<script>this.childNodes[0].childNodes[0].childNodes[0].childNodes[1].childNodes[2].setAttribute('x', '50%');</script>"></div>

<script>
google.charts.load('current',{packages:['line']});
google.charts.setOnLoadCallback(drawChart);

function drawChart() {
// Set Data
var chart_array=<?=json_encode($chart_array);?>;
var data = google.visualization.arrayToDataTable(chart_array);
// Set Options
var options = {
  title: 'Site: <?=$dept?>',
  subtitle: '% of Worker didn\'t Clock in/Out',
  vAxis: {format: '#,###%'},
  legend: {position: 'none'}
};
// Draw
var chart = new google.charts.Line(document.getElementById('myChart'));
chart.draw(data, google.charts.Line.convertOptions(options));
}
</script>

<table width="100%" style="border:1px solid">
<tr style="background-color:#888888"><td style="border:1px solid">Month</td><?for($i=0;$i<sizeof($month_array);$i++){?><td style="border:1px solid"><?=$month_array[$i][0]?></td><?}?><td style="border:1px solid">Compared to last month:</td></tr>
<tr style="background-color:#cccccc"><td style="border:1px solid">Total In</td><?for($i=0;$i<sizeof($month_array);$i++){?><td style="border:1px solid"><?=$month_array[$i][1]?></td><?}?><td align="center" valign="bottom" style="border:1px solid" rowspan=3><?$lastmonth=round($month_array[sizeof($month_array)-1][1]/$month_array[sizeof($month_array)-1][2]*100,2)-round($month_array[sizeof($month_array)-2][1]/$month_array[sizeof($month_array)-2][2]*100,2);if($lastmonth>0)echo "⇧";else echo "⇩";echo abs($lastmonth);?></td></tr>
<tr style="background-color:#888888"><td style="border:1px solid">Total DCO</td><?for($i=0;$i<sizeof($month_array);$i++){?><td style="border:1px solid"><?=$month_array[$i][2]?></td><?}?></tr>
<tr style="background-color:#cccccc"><td style="border:1px solid">%</td><?for($i=0;$i<sizeof($month_array);$i++){?><td style="border:1px solid"><?=round($month_array[$i][1]/$month_array[$i][2]*100,2)?></td><?}?></tr>
</table><br>
<table width="100%" style="border:1px solid">
<tr style="background-color:#<?=dechex(8947848+(((sizeof($incharge_array))%2)*4473924))?>"><td style="border:1px solid" rowspan=2>Incharge</td><td style="border:1px solid" align="center" colspan="<?=sizeof($month_array)?>">PRE-OT Application Report</td><td style="border:1px solid" rowspan=2>Percentage Over Total Attendance</td></tr>
<tr style="background-color:#<?=dechex(8947848+(((sizeof($incharge_array)+1)%2)*4473924))?>"><?for($i=0;$i<sizeof($month_array);$i++){?><td style="border:1px solid"><?=$month_array[$i][0]?></td><?}?></tr>
<?for($j=0;$j<sizeof($incharge_array);$j++){?>
<tr style="background-color:#<?=dechex(8947848+(($j%2)*4473924))?>"><td style="border:1px solid"><?=$incharge_array[$j][0]?></td><?for($i=0;$i<sizeof($month_array);$i++){?><td style="border:1px solid"><?=$month_array[$i][3][$j][1]?></td><?}?><td style="border:1px solid"><?=number_format(($month_array[sizeof($month_array)-1][3][$j][1])/($month_array[sizeof($month_array)-1][1])*100,2)?>%</td></tr>
<?}?>
</table><br>
<table width="100%" style="border:1px solid">
<tr style="background-color:#<?=dechex(8947848+((sizeof($otcriteria_array)%2)*4473924))?>"><td style="border:1px solid" rowspan=2>Work Category</td><?for($i=sizeof($month_array)-3;$i<sizeof($month_array);$i++){?><td style="border:1px solid" align="center" colspan=2><?=$month_array[$i][0]?></td><?}?><td style="border:1px solid" rowspan=2>Up to Date</td></tr>
<tr style="background-color:#<?=dechex(8947848+(((sizeof($otcriteria_array)+1)%2)*4473924))?>"><?for($i=sizeof($month_array)-3;$i<sizeof($month_array);$i++){?><td style="border:1px solid">Expenses</td><td style="border:1px solid">BC</td><?}?></tr>
<?for($j=0;$j<sizeof($otcriteria_array);$j++){?>
<tr style="background-color:#<?=dechex(8947848+(($j%2)*4473924))?>"><td style="border:1px solid"><?=$otcriteria_array[$j][0]?></td><?for($i=sizeof($month_array)-3;$i<sizeof($month_array);$i++){?><td style="border:1px solid"><?=$month_array[$i][4][$j][1]?></td><td style="border:1px solid"><?=number_format($month_array[$i][4][$j][2],2);$month_array[$i][5]+=$month_array[$i][4][$j][1]+$month_array[$i][4][$j][2];$month_array[$i][6]+=$month_array[$i][4][$j][2];?></td><?}?><td style="border:1px solid"><?=number_format($otcriteria_array[$j][3],2)?></td></tr>
<?}
if($dept=='SC Plot 7'){
    $total+=84259.85;
}
if($dept=='SCPT1A-1'){
    $total+=1316160.1;
}
if($dept=='SCPT1A-3(360u)'){
    $total+=996571.63;
}
if($dept=='SCPT1A-Parcel2(308u)'){
    $total+=828071.45;
}
if($dept=='FORUM2'){
    $total+=231838.08;
}
if($dept=='CYSA'){
    $total+=2427578.35;
}
if($dept=='EG2'){
    $total+=455866.00;
}
if($dept=='MK1'){
    $total+=1164198.29;
}
if($dept=='R12A-134'){
    $total+=207657.30;
}
if($dept=='SC252'){
    $total+=491188.53;
}
if($dept=='SF108'){
    $total+=43757.91;
}
if($dept=='SK-600'){
    $total+=8100.00;
}
?>
<tr style="background-color:#<?=dechex(8947848+((sizeof($otcriteria_array)%2)*4473924))?>"><td style="border:1px solid">Total</td><?for($i=sizeof($month_array)-3;$i<sizeof($month_array);$i++){?><td style="border:1px solid" colspan=2><?=$month_array[$i][5];$total+=$month_array[$i][5];?></td><?}?><td style="border:1px solid"><?=$total;?></td></tr>
<tr style="background-color:#<?=dechex(8947848+(((sizeof($otcriteria_array)+1)%2)*4473924))?>"><td style="border:1px solid">Backcharge on TMS</td><?for($i=sizeof($month_array)-3;$i<sizeof($month_array);$i++){?><td style="border:1px solid" colspan=2><?=$month_array[$i][6];$totalbc+=$month_array[$i][6];?></td><?}?><td style="border:1px solid"><?=$totalbc;?></td></tr>
<tr style="background-color:#<?=dechex(8947848+((sizeof($otcriteria_array)%2)*4473924))?>"><td style="border:1px solid">Backcharge by QS</td><?for($i=sizeof($month_array)-3;$i<sizeof($month_array);$i++){?><td style="border:1px solid" colspan=2></td><?}?><td style="border:1px solid"></td></tr>
<tr style="background-color:#<?=dechex(8947848+(((sizeof($otcriteria_array)+1)%2)*4473924))?>"><td style="border:1px solid">Net Total</td><?for($i=sizeof($month_array)-3;$i<sizeof($month_array);$i++){?><td style="border:1px solid" colspan=2><?=$month_array[$i][5]-$month_array[$i][6]?></td><?}?><td style="border:1px solid"><?=$total-$totalbc;?></td></tr>
</table>


                <?
mysql_close($dbConnection);

?>

</body>
</html>