<?php
    if(isset($_POST['submit'])) {

        $accessLevel = ($_POST['access_level']);
        $modules = $_POST['module'][$accessLevel];
        $permissions = $_POST['permissions'][$accessLevel];

        require_once ("../connection_manager.php");
        $conn = new connection_manager();
        $dbConn = $conn->connection;

        // Make sure $modules array is not empty before proceeding with the query
        if (!empty($modules)) {
            // Escape each module element individually using array_map and mysql_real_escape_string
            $escapedmodules = array_map('mysql_real_escape_string', $modules);

            // Create the DELETE query with placeholders for the IN clause
            $sqlDeletePermissions = "DELETE FROM access_permission WHERE access_level = '". $accessLevel ."' AND module IN ('" . implode("','", $escapedmodules) . "')";            
            
            // Execute the DELETE query
            $result = mysql_query($sqlDeletePermissions);

            if (!$result) {
                print_r(mysql_error());
                header("Location: ../access-level-control.php?status=stmtfailed");
                exit();
            }
        }
    
        // Insert new permissions for the specific accessLevel and modules
        if (!empty($permissions)) {
            
            foreach ($modules as $module) {
                foreach ($permissions[$module] as $permission) {
                    // Sanitize the data to prevent SQL injection (not the best approach, but necessary)
                    $accessLevel = mysql_real_escape_string($accessLevel);
                    $module = mysql_real_escape_string($module);
                    $permission = mysql_real_escape_string($permission);
        
                    // Create the INSERT query for each module and permission
                    $sqlAccessPermission = "INSERT INTO access_permission (access_level, module, permission) VALUES ('$accessLevel', '$module', '$permission')";
        
                    // Execute the INSERT query
                    $resultAccessPermission = mysql_query($sqlAccessPermission);
        
                    // Check if the query was successful
                    if (!$resultAccessPermission) {
                        header("location:../access-level-control.php?status=stmtfailed");
                        exit();
                    }
                }
            }
        }                

        // Redirect to a success page or do other actions after successful storage
        header("Location: ../access-level-control.php?status=updateSuccess");
        exit();
    }     
?>