<?php
    date_default_timezone_set("Asia/Kuala_Lumpur");
    
    if (isset($_POST['submit'])) {
        $quizQuestions = $_POST['quiz_question'];
        $quizAnswers = $_POST['quiz_answer'];     
        $selections = $_POST['selections'];
        $quizOptions = $_POST['quiz_options'];   
        $moduleID = intval($_POST['topicID']);
        $userName = 'MasterQuiz';
        $timestamp = (date('Y-m-d H:i:s'));

        // Assuming both arrays have the same length
        if (count($selections) === count($quizOptions)) {
            $combinedData = array();
            $combinedRecordsArray = array();
            
                // Loop through the received data for each question
            for ($i = 0; $i < count($quizQuestions); $i++) {
                $combinedData[] = array(
                    '(' . $selections[$i * 4] . ') ' . $quizOptions[$i * 4],
                    '(' . $selections[$i * 4 + 1] . ') ' . $quizOptions[$i * 4 + 1],
                    '(' . $selections[$i * 4 + 2] . ') ' . $quizOptions[$i * 4 + 2],
                    '(' . $selections[$i * 4 + 3] . ') ' . $quizOptions[$i * 4 + 3]
                );
            }

            foreach ($combinedData as $record) {
                $combinedRecordsArray[] = implode('## ', $record);
            }
    
            // Loop through the questions and print combined records
            for ($i = 0; $i < count($quizQuestions); $i++) {
                // echo "Question: " . $quizQuestions[$i] . "<br>";
                // echo "Answer: " . $quizAnswers[$i] . "<br>";
                // echo "Combined Records: " . $combinedRecordsArray[$i] . "<br><br>";
            }            
            
        } else {
            header("location:../operation-manual.php?status=optionsLengthError");
            exit();
        }

        require_once ("../connection_manager.php");
        $conn = new connection_manager();
        $dbConn = $conn->connection;        

        $sqlDeleteQuiz = "DELETE FROM quiz_test WHERE module_id = '". $moduleID ."' AND username = '". $userName ."'";
        
        $resultDeleteQuiz = mysql_query($sqlDeleteQuiz);          

        if (!$resultDeleteQuiz) {
            header("location:../operation-manual.php?status=quizDeleteFailed");
            exit();
        }                

        for ($i = 0; $i < count($quizQuestions); $i++) {
            $quizQuestion = htmlspecialchars($quizQuestions[$i], ENT_QUOTES);
            $quizAnswer = htmlspecialchars($quizAnswers[$i], ENT_QUOTES);
            $quizOption = htmlspecialchars($combinedRecordsArray[$i], ENT_QUOTES);

            $sqlInsertQuiz = "INSERT INTO quiz_test (module_id, question, answer, answer_option, username, timestamp) 
                              VALUES ('$moduleID', '$quizQuestion', '$quizAnswer', '$quizOption', '$userName', '$timestamp')";
            
            $resultInsertQuiz = mysql_query($sqlInsertQuiz);            

            if (!$resultInsertQuiz) {                
                header("location:../operation-manual.php?status=quizInsertFailed");
                exit();
            }
        }        
                        
        header("location:../operation-manual.php?topic=".$moduleID."&status=quizSuccess");
        exit();
    }
?>