<?php
    if (isset($_POST["submit"])) {

        // Retrieve form data
        $title = htmlspecialchars($_POST['videoTitle'], ENT_QUOTES);
        $url = htmlspecialchars($_POST['videoLink'], ENT_QUOTES);
        $category = htmlspecialchars($_POST['category'], ENT_QUOTES);
        $creator = htmlspecialchars($_POST['creator'], ENT_QUOTES);
        $description = htmlspecialchars($_POST['description'], ENT_QUOTES);
        $flowchart = htmlspecialchars($_FILES["flowchart"]["name"], ENT_QUOTES);
        
        require_once ("../connection_manager.php");
        $conn = new connection_manager();
        $dbConn = $conn->connection;

        // replace youtu.be with youtube.com/embed
        $url = str_replace("youtu.be/", "youtube.com/embed/", $url);

        // check if the flowchart is exist to INSERT the database
        if ($flowchart != '') {
            // Set image name and get image type
            $timestampPicture = time();
            $flowchart = "images/trainingmodules/". $category . "-" . $timestampPicture . "-" . basename($_FILES["flowchart"]["name"]);
            $imageFileType  = strtolower(pathinfo($flowchart,PATHINFO_EXTENSION));                        

            if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg") {
                $error_msg = "Sorry, only JPG, JPEG & PNG files are allowed.";
                header("location:../operation-manual.php?status=wrongFileType");
                exit(); //stop
            } else {

                // Set temporary file name
                $tempname = $_FILES["flowchart"]["tmp_name"];

                $sqlTrainingModule = "INSERT INTO training_module (category, title, video_url, creator, description, flowchart) 
                        VALUES ('$category', '$title', '$url', '$creator', '$description', '$flowchart')";

                $stmt = mysql_query($sqlTrainingModule);            
                if (!$stmt) {                 
                    header("location:../operation-manual.php?status=insertFailed");                              
                    exit(); //stop
                }

                // Create folder to store images
                $file_path = "../images/trainingmodules/";
                if (!is_dir($file_path)) {
                    mkdir($file_path, 0777, true);
                }  

                // Now let's move the uploaded image into the folder: image
                move_uploaded_file($tempname, "../". $flowchart);    
            }

            //Get the ID of the inserted training_module row
            $trainingModuleId = mysql_insert_id();  

            $timestamps = $_POST['timestamps'];
            $descriptions = $_POST['descriptions'];
                    
            for ($i = 0; $i < count($timestamps); $i++) {
                $timestamp = htmlspecialchars($timestamps[$i], ENT_QUOTES);
                $description = htmlspecialchars($descriptions[$i], ENT_QUOTES);

                // Insert into training_module_timeline table
                $sqlTimeline = "INSERT INTO training_module_timeline (module_id, timestamp, description) VALUES ('$trainingModuleId', '$timestamp', '$description')";
                $stmt2 = mysql_query($sqlTimeline);
                        
                if (!$stmt2) {
                    header("location:../operation-manual.php?status=insertFailed2");                                
                    exit(); //stop
                }
            }  
        } else {
            $sqlTrainingModule = "INSERT INTO training_module (category, title, video_url, creator, description) 
            VALUES ('$category', '$title', '$url', '$creator', '$description')";

            $stmt = mysql_query($sqlTrainingModule);            
            if (!$stmt) {                 
                header("location:../operation-manual.php?status=insertFailed");                              
                exit(); //stop
            }
            
            //Get the ID of the inserted training_module row
            $trainingModuleId = mysql_insert_id();  

            $timestamps = $_POST['timestamps'];
            $descriptions = $_POST['descriptions'];
                    
            for ($i = 0; $i < count($timestamps); $i++) {
                $timestamp = htmlspecialchars($timestamps[$i], ENT_QUOTES);
                $description = htmlspecialchars($descriptions[$i], ENT_QUOTES);

                // Insert into training_module_timeline table
                $sqlTimeline = "INSERT INTO training_module_timeline (module_id, timestamp, description) VALUES ('$trainingModuleId', '$timestamp', '$description')";
                $stmt2 = mysql_query($sqlTimeline);
                        
                if (!$stmt2) {
                    header("location:../operation-manual.php?status=insertFailed2");                                
                    exit(); //stop
                }
            }  
            
        }
        header("location:../operation-manual.php?topic=".$trainingModuleId."&status=createSuccess");
        exit(); //stop
    }
    
?>